// New Menu, by Feek.

function Menu(x,y,w,h)
{
	this.items = new Array();
	this.name = "";
	this.x = x;
	this.y = y;
	this.w = w;
	this.h = h;
	
	this.currentItem = 0;
}

Menu.prototype.addItem = function(Name,returnto, color, highlight)
{
	if (color == undefined)
	{
		color = White;
	}
	if (highlight == undefined)
	{
		highlight = BabyBlue;
	}
	if (color == true)
	{
		color = White;
	}
	if (color == false)
	{
		color = GrayHaze;
		highlight = Gray;
	}
	var item = new Object;
	item.name = Name;
	item.highlight = highlight;
	item.returnto = returnto;
	item.color = color;
	this.items[this.items.length] = item;
}

Menu.prototype.returnCurrentItem = function()
{
	return this.currentItem;
}

Menu.prototype.blit = function()
{
	if (this.h == undefined)
	{
		this.h = this.items.length*font.getHeight();
	}
	font.setColorMask(White);
	font.drawText(this.x + (this.w/2)-(font.getStringWidth(this.name)/2),this.y-24,this.name);
	window.drawWindow(this.x,this.y,this.w,this.h);
	
	if (mx > this.x && my > this.y && mx < this.x+this.w && my < this.y + this.h)
	{
		if (IsMouseButtonPressed(MOUSE_LEFT) == true && this.items[this.currentItem].highlight != Gray)
		{
			Delay(125);
			this.items[this.currentItem].returnto();
			return;
		}
	}

	for(var i = 0; i < this.items.length; ++i)
	{
		if (mx > this.x && my > this.y && mx < this.x+this.w && my < this.y + this.h)
		{
			if (my > this.y+i*font.getHeight())
			{
				this.currentItem = i;
			}
		}
	}
			
	for(var i = 0; i < this.items.length; ++i)
	{
		if (i != this.currentItem)
		{
			font.setColorMask(this.items[i].color);
		}
		if (i == this.currentItem)
		{
			font.setColorMask(this.items[i].highlight);
		}
		font.drawText(this.x + (this.w/2)-(font.getStringWidth(this.items[i].name)/2),this.y+i*font.getHeight(),this.items[i].name);
	}
}

Menu.prototype.draw = function()
{
	var screen = GrabImage(0,0,sw,sh);
	Delay(125);
	while(!IsKeyPressed(KEY_ESCAPE))
	{
		screen.blit(0,0);
		if (this.h == undefined)
		{
			
			this.h = this.items.length*font.getHeight();
		}
		font.setColorMask(White);
		font.drawText(this.x + (this.w/2)-(font.getStringWidth(this.name)/2),this.y-24,this.name);
		window.drawWindow(this.x,this.y,this.w,this.h);
		
		if (mx > this.x && my > this.y && mx < this.x+this.w && my < this.y + this.h)
		{
			if (IsMouseButtonPressed(MOUSE_LEFT) == true && this.items[this.currentItem].highlight != Gray)
			{
				Delay(125);
				this.items[this.currentItem].returnto();
				return;
			}
		}
	
		for(var i = 0; i < this.items.length; ++i)
		{
			if (mx > this.x && my > this.y && mx < this.x+this.w && my < this.y + this.h)
			{
				if (my > this.y+i*font.getHeight())
				{
					this.currentItem = i;
				}
			}
		}
				
		for(var i = 0; i < this.items.length; ++i)
		{
			if (i != this.currentItem)
			{
				font.setColorMask(this.items[i].color);
			}
			if (i == this.currentItem)
			{
				font.setColorMask(this.items[i].highlight);
			}
			font.drawText(this.x + (this.w/2)-(font.getStringWidth(this.items[i].name)/2),this.y+i*font.getHeight(),this.items[i].name);
		}
		cursor.Draw();
		FlipScreen();
	}
}