// Fade object code by Feek.

function FadeOut(miliseconds)
{
	var image = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
	var color = CreateColor(0,0,0);
	var time = GetTime();
	while (GetTime() - time < miliseconds)
	{
		color.alpha = (GetTime() - time) * 255 / miliseconds;
		image.blit(0, 0);
		ApplyColorMask(color);
		FlipScreen();
	}
	color.alpha = 255;
	image.blit(0, 0);
	ApplyColorMask(color);
	FlipScreen();
	image.blit(0, 0);
}

function FadeIn(miliseconds)
{
	var image = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
	var color = CreateColor(0,0,0);
	var time = GetTime();
	while (GetTime() - time < miliseconds)
	{
		color.alpha = 255 - (GetTime() - time) * 255 / miliseconds;
		image.blit(0, 0);
		ApplyColorMask(color);
		FlipScreen();
	}
	color.alpha = 0;
	image.blit(0, 0);
	ApplyColorMask(color);
	FlipScreen();
	image.blit(0, 0);
}