// Puzzle generator. by Feek.

function Puzzle(name,w,h,l)
{
	this.blocks        = new Array();
	this.name          = name;
	this.width         = w;
	this.height        = h;
	this.level         = l;
	this.x             = (sw/2)-(w*16);
	this.y             = (sh/2)-(h*16);
	this.answered      = false;
	this.menu          = false;
	
	var column         = " ";
	this.ColumnAnswer  = 0;
	var row            = " ";
	this.RowAnswer     = 0;
	
	this.answerstoget  = 0;
	this.areanswered   = 0;
	
	var n1 = 0;
	var n2 = 0;
	var n3 = 0;
	var n4 = 0;
	var n5 = 0;
	var n6 = 0;
	var n7 = 0;
	var n8 = 0;
	var n9 = 0;
}

Puzzle.prototype.addBlock = function(clickable)
{
	var block         = new Object;
	block.image       = Tile
	block.clickable   = clickable;
	block.number      = "";
	block.numbercolor = White;
	block.row         = 0;
	block.column      = 0;
	this.blocks[this.blocks.length] = block;
}

Puzzle.prototype.addNBlock = function(num1,num2)
{
	var block          = new Object;
	block.image        = NumberTile;
	block.answerimage1 = null;
	block.answerimage2 = null;
	block.num1         = num1;
	block.num2         = num2;
	block.answernum1   = false;
	block.answernum2   = false;
	block.clickable    = true;
	block.numblock     = true;
	block.row          = 0;
	block.column       = 0;
	this.blocks[this.blocks.length] = block;
}

Puzzle.prototype.generate = function()
{
	var number = 0;
	var CurrentNumber = 0;
	var NumberInput = false;
	for (var i = 0; i < this.blocks.length; ++i)
	{
		if (this.blocks[i].numblock == true)
		{
			if (this.blocks[i].num1 != "n")
			{
				this.answerstoget++;
			}
			if (this.blocks[i].num2 != undefined)
			{
				this.answerstoget++;
			}
		}
	}
	while(1) // main game loop
	{
		background.blit(0,0);
		font.setColorMask(White);
		font.drawText(0,0,"Spherekuro-level " + this.level);
		font.drawText(this.x+((this.width*32/2)-(font.getStringWidth(this.name)/2)),this.y-font.getHeight(),this.name);
		number = 0;
		for (var i = 0; i < this.height; ++i)
		{
			for (var j = 0; j < this.width; ++j)
			{
				if (this.blocks[number] != undefined)
				{
					this.blocks[number].image.blit(this.x+j*32,this.y+i*32);
					if (this.blocks[number].answerimage1 != null)
					{
						this.blocks[number].answerimage1.blit(this.x+j*32,this.y+i*32);
					}
					if (this.blocks[number].answerimage2 != null)
					{
						this.blocks[number].answerimage2.blit(this.x+j*32,this.y+i*32);
					}
					this.blocks[number].row = i+1;
					this.blocks[number].column = j+1;
					if (this.blocks[number].numblock == true && this.answered == false)
					{
						if (this.blocks[number].num1 > 0)
						{
							column = j+1; // x
							this.checkColumn(column,this.blocks[number].num1,number);
						}
						if (this.blocks[number].num2 > 0)
						{
							row = i+1; // y
							this.checkRow(row,this.blocks[number].num2,number);
						}
						row = " ";
						column = " ";
					}
					if (number == CurrentNumber-1 && this.blocks[number].clickable == true && this.IsMouseInPuzzle() == true && this.answered == false && this.blocks[number].numblock == undefined)
					{
						Rectangle(4+this.x+j*32,4+this.y+i*32,24,24,WhiteHaze);
						if (IsMouseButtonPressed(MOUSE_LEFT) == true && this.blocks[CurrentNumber-1].clickable == true)
						{
							NumberInput = true;
						}
						if (IsMouseButtonPressed(MOUSE_RIGHT) == true && this.blocks[CurrentNumber-1].clickable == true)
						{
							this.blocks[CurrentNumber-1].numbercolor = White; 
							this.blocks[CurrentNumber-1].number = "";
						}
					}
					if (this.blocks[number].clickable == false)
					{
						Rectangle(this.x+j*32,this.y+i*32,32,32,BlackHaze)
					}
					if (this.blocks[number].number != undefined)
					{
						font3.setColorMask(this.blocks[number].numbercolor);
						font3.drawText(10+this.x+j*32,8+this.y+i*32,this.blocks[number].number);
					}
					if (this.blocks[number].num1 != undefined && this.blocks[number].num1 != "n")
					{
						font2.drawText(4+this.x+j*32,19+this.y+i*32,this.blocks[number].num1);
					}
					if (this.blocks[number].num2 != undefined)
					{
						font2.drawText(13+this.x+j*32,5+this.y+i*32,this.blocks[number].num2);
					}
					number+=1;
				}
				if (this.IsMouseInPuzzle() == true)
				{
					if (mx > this.x+j*32 && my > this.y+i*32 && mx < 32+this.x+j*32 && my < 32+this.y+i*32)
					{
						CurrentNumber = number;
					}
				}
			}
		}
  
	  // Manipulating...
	  
	  if (NumberInput == true)
	  {
			window.drawWindow(sw/2-font.getStringWidth("Type in a number.")/2,sh-32,font.getStringWidth("Type in a number."),24);
			font.drawText(sw/2-font.getStringWidth("Type in a number.")/2,sh-28,"Type in a number.");
		}
		QuitButton.blit((this.x+this.width*16)-60,8+this.y+this.height*32);
		if (mx > (this.x+this.width*16)-60 && my > 8+this.y+this.height*32 && mx < 60+this.x+this.width*16 && my < 8+(this.y+this.height*32)+24)
		{
			if (IsMouseButtonPressed(MOUSE_LEFT) == true)
			{
				LevelSelection();
			}
		}
		if (this.menu == true)
		{
			InGameMenu.draw();
			this.menu = false;
		}
		cursor.Draw();
	  if (this.answered == true)
	  {
			window.drawWindow(sw/2-font.getStringWidth("You have finished this level!")/2,sh/2-12,font.getStringWidth("You have finished this level!")+8,24)
			font.drawTextBox(4+sw/2-font.getStringWidth("You have finished this level!")/2,sh/2-8,font.getStringWidth("You have finished this level!"),16,0,"You have finished this level!");
			FadeOut(1024);
			break;
	  }
		FlipScreen();
	  if (NumberInput == true)
	  {
			this.blocks[CurrentNumber-1].numbercolor = White;
			if (this.blocks[CurrentNumber-1] != undefined)
			{
				this.blocks[CurrentNumber-1].number = "";
				ClearKeyQueue();
				this.blocks[CurrentNumber-1].number = GetNumberKey();
			}
			NumberInput = false;
	  }
	  this.checkAnswer();
		if (IsKeyPressed(KEY_ESCAPE) == true)
		{
			this.menu = true;
		}
	}
	if (NextLevel != 6)
	{
		NextLevel = this.level+1;
	}
	LevelSelection();
}

Puzzle.prototype.IsMouseInPuzzle = function()
{
  if (mx > this.x && my > this.y && mx < this.x+(this.width*32) && my < this.y+(this.height*32))
	{
		return true;
	}
	else
	{
		return false;
	}
}

Puzzle.prototype.checkColumn = function(column,answer,number)
{
	this.ColumnAnswer = 0;
	n1 = 0;
	n2 = 0;
	n3 = 0;
	n4 = 0;
	n5 = 0;
	n6 = 0;
	n7 = 0;
	n8 = 0;
	n9 = 0;
	for (var i = number+1; i < this.blocks.length; ++i)
	{
		if (this.blocks[i].column == column)
		{
			if (this.blocks[i].number > 0)
			{
				this.ColumnAnswer += this.blocks[i].number;
				this.SetNumber(this.blocks[i].number);
			}
			if (this.blocks[i].clickable == false)
			{
				break;
			}
			if (this.blocks[i].numblock == true)
			{
				break;
			}
		}
	}
	if (this.ColumnAnswer < answer)
	{
		this.blocks[number].answerimage1 = null;
		this.blocks[number].answernum1   = false;
	}
	if (this.ColumnAnswer > answer)
	{
		this.blocks[number].answerimage1 = null;
		this.blocks[number].answernum1   = false;
	}
	if (this.ColumnAnswer == answer)
	{
		this.blocks[number].answerimage1 = NumberBlock1;
		this.blocks[number].answernum1   = true;
	}
	for (var i = number+1; i < this.blocks.length; ++i)
	{
		if (this.blocks[i].column == column)
		{
			if (this.blocks[i].clickable == false)
			{
				break;
			}
			if (this.blocks[i].numblock == true)
			{
				break;
			}
			if (this.blocks[i].number >= answer)
			{
				this.blocks[number].answerimage1 = null;
				this.blocks[number].answernum1   = false;
			}
		}
	}
	if (this.FindRepeateNumber() == true)
	{
		this.blocks[number].answerimage1 = null;
		this.blocks[number].answernum1   = false;
	}
}

Puzzle.prototype.checkRow = function(row,answer,number)
{
	this.RowAnswer = 0;
	n1 = 0;
	n2 = 0;
	n3 = 0;
	n4 = 0;
	n5 = 0;
	n6 = 0;
	n7 = 0;
	n8 = 0;
	n9 = 0;
	for (var i = number+1; i < this.blocks.length; ++i)
	{
		if (this.blocks[i].row == row)
		{
			if (this.blocks[i].number > 0)
			{
				this.RowAnswer += this.blocks[i].number;
				this.SetNumber(this.blocks[i].number);
			}
			if (this.blocks[i].clickable == false)
			{
				break;
			}
			if (this.blocks[i].numblock == true)
			{
				break;
			}
		}
	}
	if (this.RowAnswer < answer)
	{
		this.blocks[number].answerimage2 = null;
		this.blocks[number].answernum2   = false;
	}
	if (this.RowAnswer > answer)
	{
		this.blocks[number].answerimage2 = null;
		this.blocks[number].answernum2   = false;
	}
	if (this.RowAnswer == answer)
	{
		this.blocks[number].answerimage2 = NumberBlock2;
		this.blocks[number].answernum2   = true;
	}
	for (var i = number+1; i < this.blocks.length; ++i)
	{
		if (this.blocks[i].row == row)
		{
			if (this.blocks[i].clickable == false)
			{
				break;
			}
			if (this.blocks[i].numblock == true)
			{
				break;
			}
			if(this.blocks[i].number >= answer)
			{
				this.blocks[number].answerimage2 = null;
				this.blocks[number].answernum2   = false;
			}
		}
	}
	if (this.FindRepeateNumber() == true)
	{
		this.blocks[number].answerimage2 = null;
		this.blocks[number].answernum2   = false;
	}
}

Puzzle.prototype.checkAnswer = function()
{
	this.areanswered = 0;
	for (var i = 0; i < this.blocks.length; ++i)
	{
		if (this.blocks[i].answernum1 == true)
		{
			this.areanswered++;
		}
		if (this.blocks[i].answernum2 == true)
		{
			this.areanswered++;
		}
	}
	if (this.areanswered == this.answerstoget)
	{
		this.answered = true;
	}
}

Puzzle.prototype.SetNumber = function(num) // doesn't return numbers, just sets and continues.
{
	if (num == 1)
	{
		n1++;
	}
	if (num == 2)
	{
		n2++;
	}
	if (num == 3)
	{
		n3++;
	}
	if (num == 4)
	{
		n4++;
	}
	if (num == 5)
	{
		n5++;
	}
	if (num == 6)
	{
		n6++;
	}
	if (num == 7)
	{
		n7++;
	}
	if (num == 8)
	{
		n8++;
	}
	if (num == 9)
	{
		n9++;
	}
}
Puzzle.prototype.FindRepeateNumber = function()
{
	if (n1 >= 2)
	{
		return true;
	}
	else if (n2 >= 2)
	{
		return true;
	}
	else if (n3 >= 2)
	{
		return true;
	}
	else if (n4 >= 2)
	{
		return true;
	}
	else if (n5 >= 2)
	{
		return true;
	}
	else if (n6 >= 2)
	{
		return true;
	}
	else if (n7 >= 2)
	{
		return true;
	}
	else if (n8 >= 2)
	{
		return true;
	}
	else if (n9 >= 2)
	{
		return true;
	}
	else
	{
		return false; // no number repeates twice or more
	}
	
}

function ClearKeyQueue() { 
  while (AreKeysLeft()) GetKey(); 
}

function GamePlay(level)
{
	LoadLevels();
	switch(level)
	{
		case 1:
		puzzle1.generate();
		break;
		case 2:
		puzzle2.generate();
		break;
		case 3:
		puzzle3.generate();
		break;
		case 4:
		puzzle4.generate();
		break;
		case 5:
		puzzle5.generate();
		break;
		case 6:
		puzzle6.generate();
		break;
		/*case 7:
		puzzle7.generate();
		break;
		case 8:
		puzzle8.generate();
		break;
		case 9:
		puzzle9.generate();
		break;
		case 10:
		puzzle10.generate();
		break;
		case 11:
		puzzle11.generate();
		break;
		case 12:
		puzzle12.generate();
		break;
		case 13:
		puzzle13.generate();
		break;
		case 14:
		puzzle14.generate();
		break;
		case 15:
		puzzle15.generate();
		break;*/
	}
}